import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner
import re

class MainTest(unittest.TestCase):

    def test_answer(self):

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        main()
        sys.stdout = sys.__stdout__ 

        checkQuery = [
            'Denmark 8.71%',
            'Finland 12.22%',
            'Iceland 17.50%',
            'Norway 53.48%',
            'Sweden 8.09%'
        ]
        output = list(capturedOutput.getvalue().strip().split("\n"))
        if output[-1] == "":
            output.pop()
        
        checkBool = True
        for n in output:
            if n not in checkQuery:
                checkBool = False
            else:
                checkQuery.remove(n)

        if len(checkQuery) > 0:
            checkBool = False

        r = re.compile(r'\w+\s\d+\.\d{2}%')
        isFormatCorrect = all(r.match(line) for line in output)
        self.assertTrue(isFormatCorrect, "The output format is incorrect. Please take a look at the example output.")

        self.assertTrue(checkBool, "Incorrect answer. Please check your code.")

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())